/***************************************************************************
                               cmappluginstandard.cpp
                             -------------------
    begin                : Mon Aug 6 2001
    copyright            : (C) 2001 by Kmud Developer Team
    email                : kmud-devel@kmud.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "cmappluginstandard.h"

#include "cmapstandardfactory.h"

#include "tools/cmaptoolselect.h"
#include "tools/cmaptoolroom.h"
#include "tools/cmaptoolpath.h"
#include "tools/cmaptooltext.h"
#include "tools/cmaptoolzone.h"
#include "tools/cmaptooleraser.h"
#include "views/cmapoverviewmanager.h"
#include "propertyPanes/cmapnotespane.h"

#include "../../cmapmanager.h"



#include <qiconset.h>


#include <kstddirs.h>

CMapPluginStandard::CMapPluginStandard(CMapManager *manager,QObject *parent, const char *name ) : CMapPluginBase(manager,parent,name)
{
	// setting instance name
	setInstance(CMapStandardFactory::instance());

	setXMLFile (locate("data", "kmudmapper/plugins/kmudmapper_standard.rc"));

	// Create and Add the tools to the tools list
	toolList.append(new CMapToolSelect(actionCollection(),manager,parent,name));
	toolList.append(new CMapToolRoom(actionCollection(),manager,parent,name));
	toolList.append(new CMapToolPath(actionCollection(),manager,parent,name));
	toolList.append(new CMapToolText(actionCollection(),manager,parent,name));
	toolList.append(new CMapToolZone(actionCollection(),manager,parent,name));
	toolList.append(new CMapToolEraser(actionCollection(),manager,parent,name));

	// Create and Add the views to the views list
	viewList.append(new CMapOverviewManager(actionCollection(),manager,parent,name));

	actionCollection()->action("viewOverview")->setEnabled(false);
	actionCollection()->action("toolsEraser")->setEnabled(false);
	actionCollection()->action("toolsPath")->setEnabled(false);
	actionCollection()->action("toolsRoom")->setEnabled(false);
	actionCollection()->action("toolsSelect")->setEnabled(false);
	actionCollection()->action("toolsText")->setEnabled(false);
	actionCollection()->action("toolsZone")->setEnabled(false);

}

CMapPluginStandard::~CMapPluginStandard()
{
}

/** Used to get a list of the property pages for a map element */
QList<CMapPropertiesPaneBase> CMapPluginStandard::getPropertyPanes(elementTyp type,CMapElement *element,QWidget *parent)
{
	QList<CMapPropertiesPaneBase> list;

	if (type == ROOM || type == ZONE)
	{
		list.append(new CMapNotesPane(i18n("Notes"),NULL,type,element,parent,"notesPane"));
	}

	return list;
}

/** This is called when the character or mud profiles change */
void CMapPluginStandard::profileChanged(void)
{
	actionCollection()->action("viewOverview")->setEnabled(true);
	actionCollection()->action("toolsEraser")->setEnabled(true);
	actionCollection()->action("toolsPath")->setEnabled(true);
	actionCollection()->action("toolsRoom")->setEnabled(true);
	actionCollection()->action("toolsSelect")->setEnabled(true);
	actionCollection()->action("toolsText")->setEnabled(true);
	actionCollection()->action("toolsZone")->setEnabled(true);
}
